select
    (case when (nti.saidaimediata=1) then 'Estoque' else 'Direta' end) as tipo, 
    (case when(nt.tiponota='E')then 'Entrada' else 'Sada' end) as sentido, 
    'movimentao direta' as tipomovimento,          
    nt.numdocumento, 
    nt.dtentradasaida as data_apropriacao, 
    cc.numero ||' - '||cc.descricao as centro_custo,
    sa.descricao as safra,
    cast((case when (nia.cdcentrocusto is not null) then nia.percentual else null end) as decimal(15,2)) as percentual_tela,
    cg.numero ||' - '|| cg.descricao as conta_gerencial, 
    fr.nome as fornecedor, 
    pr.numero as numero_produto, 
    pr.nome as nome_produto, 
    nti.qtde as quantidade, 
    cast((nti.vrtotal / nti.qtde) as decimal(15,2)) as valor_unitario,
    cast(nti.vrtotal as decimal(15,2)) as valor_total,
    cast((case when (nia.percentual is null) then nti.vrtotal else ((nti.vrtotal * nia.percentual) / 100) end) as decimal(15,2)) as valor_apropriado_cc_nota,
    ccfin.numero ||' - '|| ccfin.descricao as centro_custo_final,
    cast((case when (rai.cdrateioitem is not null) then rai.percentual else null end) as decimal(15,2)) as percentual_rateio_final,
    cast((case
        when (ccfin.cdcentrocusto is null)
          then (case when (nia.percentual is null) then nti.vrtotal else ((nti.vrtotal * nia.percentual) / 100) end)
        else (((case when (nia.percentual is null) then nti.vrtotal else ((nti.vrtotal * nia.percentual) / 100) end) * rai.percentual) / 100)
        end) as decimal(15,2)) as valor_apropriado_final,
    extract (month from nt.dtentradasaida) as mes, 
    extract (year from nt.dtentradasaida) as ano 
from 
    notaitem nti
    join nota nt on nti.cdnota=nt.cdnota
    join contagerencial cg on nti.cdcontagerencial=cg.cdcontagerencial
    join notaitemapro nia on nti.cdnotaitem=nia.cdnotaitem
    join centrocusto cc on nia.cdcentrocusto=cc.cdcentrocusto
    left join safra sa on nia.cdsafra = sa.cdsafra
    join produto pr on nti.cdproduto=pr.cdproduto
    left join pessoa fr on nt.cdpessoa=fr.cdpessoa
    left join rateio ra on ra.cdcentrocusto = cc.cdcentrocusto and nt.dtentradasaida between ra.dtrateio and coalesce(ra.dtfimrateio, current_date)
    left join rateioitem rai on rai.cdrateio = ra.cdrateio
    left join centrocusto ccfin on ccfin.cdcentrocusto = rai.cdcentrocusto
where 
    ((nti.estocavel = 0) or (nti.estocavel='1' and nti.saidaimediata='1'))
    and nt.prevista='0'
    and nt.cdnotavinculada is null
    and extract(year from nt.dtentradasaida) = 2017
order by 
    nt.dtemissao, nt.cdnota, nti.cdnotaitem
